var should=require("should");
var assert=require("assert");
var path=require("path");

var TDPJSONCurator=require(path.join(__dirname, "../TDPJSONCurator.js"));




// ASYNC TESTS
describe("Sync tests", function()
{

// CONSTRUCTOR TESTS

// SET()'s
	describe("Sync constructor test 1", function()
	{
		var objectToCurate=
		{
			num:100,
			str:"Some string",
			obj:
			{
				a:"bcd"
			},
			bool:true,
			mixed:"blah blah"
		};

		var JSONObjectSpec=
		{
			num:
			{
				allowedTypes:["number"],
				allowedValues:[1,100,1000,10000]
			},
			str:
			{
				allowedTypes:["string"]
			},
			obj:
			{
				allowedTypes:["object"]
			},
			bool:
			{
				allowedTypes:["boolean"]
			},
			mixed:
			{
				
			}
		};

		
		var curator=new TDPJSONCurator();

		// Invalid objectToCurate
		it("Should throw when objectToCurate is not an object", function()
		{
			(function()
			{
				curator.curate("abc", JSONObjectSpec, true, function(ret)
				{
				})
			}).should.throw();
		});
	});



	describe("Sync constructor test 2", function()
	{
		var objectToCurate=
		{
			num:100,
			str:"Some string",
			obj:
			{
				a:"bcd"
			},
			bool:true,
			mixed:"blah blah"
		};

		var JSONObjectSpec=
		{
			num:
			{
				allowedTypes:["number"],
				allowedValues:[1,100,1000,10000]
			},
			str:
			{
				allowedTypes:["string"]
			},
			obj:
			{
				allowedTypes:["object"]
			},
			bool:
			{
				allowedTypes:["boolean"]
			},
			mixed:
			{
				
			}
		};

		
		var curator=new TDPJSONCurator();

		// Invalid JSONObjectSpec
		it("Should return throw when JSONObjectSpec is not an object", function()
		{
			(function()
			{
				curator.curate(objectToCurate, "abc", true, function(ret)
				{
				})
			}).should.throw();
		});
	});


	describe("Sync constructor test 3", function()
	{
		var objectToCurate=
		{
			num:100,
			str:"Some string",
			obj:
			{
				a:"bcd"
			},
			bool:true,
			mixed:"blah blah"
		};

		var JSONObjectSpec=
		{
			num:
			{
				allowedTypes:["number"],
				allowedValues:[1,100,1000,10000]
			},
			str:
			{
				allowedTypes:["string"]
			},
			obj:
			{
				allowedTypes:["object"]
			},
			bool:
			{
				allowedTypes:["boolean"]
			},
			mixed:
			{
				
			}
		};

		
		var curator=new TDPJSONCurator();


		// Invalid objectToCurate and JSONObjectSpec
		it("Should throw when objectToCurate and JSONObjectSpec are not objects", function()
		{
			(function()
			{
				curator.curate("abc", "abc", true, function(ret)
				{
				})
			}).should.throw();
		});
	});


	describe("Sync constructor test 4", function()
	{
		var objectToCurate=
		{
			num:100,
			str:"Some string",
			obj:
			{
				a:"bcd"
			},
			bool:true,
			mixed:"blah blah"
		};

		var JSONObjectSpec=
		{
			num:
			{
				allowedTypes:["number"],
				allowedValues:[1,100,1000,10000]
			},
			str:
			{
				allowedTypes:["string"]
			},
			obj:
			{
				allowedTypes:["object"]
			},
			bool:
			{
				allowedTypes:["boolean"]
			},
			mixed:
			{
				
			}
		};

		
		var curator=new TDPJSONCurator();

		// Invalid JSONObjectSpec
		it("Should throw when callback is not a function", function()
		{
			(function()
			{
				curator.curate(objectToCurate, JSONObjectSpec, true, "abc");
			}).should.throw();
		});
	});

	describe("Sync constructor test 5", function()
	{
		var objectToCurate=
		{
			num:100,
			str:"Some string",
			obj:
			{
				a:"bcd"
			},
			bool:true,
			mixed:"blah blah"
		};

		var JSONObjectSpec=
		{
			num:
			{
				allowedTypes:["number"],
				allowedValues:[1,100,1000,10000]
			},
			str:
			{
				allowedTypes:["string"]
			},
			obj:
			{
				allowedTypes:["object"]
			},
			bool:
			{
				allowedTypes:["boolean"]
			},
			mixed:
			{
				
			}
		};

		
		var curator=new TDPJSONCurator();


		// Full example, should work correctly:
		curator.curate(objectToCurate, JSONObjectSpec, true, function(ret)
		{
			it("Should return an object which is identical to that which is provided as an argument with valid curate() arguments", function()
			{		
				assert.deepEqual(ret, objectToCurate);
			});
		});
	});


	describe("Sync constructor test 6", function()
	{
		var objectToCurate=
		{
			num:100,
			str:"Some string",
			obj:
			{
				a:"bcd"
			},
			bool:true,
			mixed:"blah blah"
		};

		var JSONObjectSpec=
		{
			num:
			{
				allowedTypes:["number"],
				allowedValues:[1,100,1000,10000]
			},
			str:
			{
				allowedTypes:["string"]
			},
			obj:
			{
				allowedTypes:["object"]
			},
			bool:
			{
				allowedTypes:["boolean"]
			},
			mixed:
			{
				
			}
		};

		
		var curator=new TDPJSONCurator(objectToCurate, JSONObjectSpec, true);

		var prop="num";
		var val=1;
		// get example, should work correctly:
		curator.set(prop, val, function(ret)
		{
			it("Should return true for a successful set()", function()
			{		
				ret.should.be.an.Object;
				ret.num.should.eql(val);
				ret.str.should.eql(objectToCurate.str);
				ret.obj.should.eql(objectToCurate.obj);
				ret.bool.should.eql(objectToCurate.bool);
				ret.mixed.should.eql(objectToCurate.mixed);
			});
		});
	});


	describe("Sync constructor test 7", function()
	{
		var objectToCurate=
		{
			num:100,
			str:"Some string",
			obj:
			{
				a:"bcd"
			},
			bool:true,
			mixed:"blah blah"
		};

		var JSONObjectSpec=
		{
			num:
			{
				allowedTypes:["number"],
				allowedValues:[1,100,1000,10000]
			},
			str:
			{
				allowedTypes:["string"]
			},
			obj:
			{
				allowedTypes:["object"]
			},
			bool:
			{
				allowedTypes:["boolean"]
			},
			mixed:
			{
				
			}
		};

		
		var curator=new TDPJSONCurator(objectToCurate, JSONObjectSpec, true);

		var prop="str";
		var val="Hello, World!";
		// get example, should work correctly:
		curator.set(prop, val, function(ret)
		{
			it("Should return true for a successful set()", function()
			{		
				ret.should.be.an.Object;
				ret.num.should.eql(objectToCurate.num);
				ret.str.should.eql(val);
				ret.obj.should.eql(objectToCurate.obj);
				ret.bool.should.eql(objectToCurate.bool);
				ret.mixed.should.eql(objectToCurate.mixed);
			});
		});
	});

	describe("Sync constructor test 8", function()
	{
		var objectToCurate=
		{
			num:100,
			str:"Some string",
			obj:
			{
				a:"bcd"
			},
			bool:true,
			mixed:"blah blah"
		};

		var JSONObjectSpec=
		{
			num:
			{
				allowedTypes:["number"],
				allowedValues:[1,100,1000,10000]
			},
			str:
			{
				allowedTypes:["string"]
			},
			obj:
			{
				allowedTypes:["object"]
			},
			bool:
			{
				allowedTypes:["boolean"]
			},
			mixed:
			{
				
			}
		};

		
		var curator=new TDPJSONCurator(objectToCurate, JSONObjectSpec, true);

		var prop="obj";
		var val={k1:"v1",k2:"v2"};
		// get example, should work correctly:
		curator.set(prop, val, function(ret)
		{
			it("Should return true for a successful set()", function()
			{		
				ret.should.be.an.Object;
				ret.num.should.eql(objectToCurate.num);
				ret.str.should.eql(objectToCurate.str);
				assert.deepEqual(ret.obj, val);
				ret.bool.should.eql(objectToCurate.bool);
				ret.mixed.should.eql(objectToCurate.mixed);
			});
		});
	});


	describe("Sync constructor test 9", function()
	{
		var objectToCurate=
		{
			num:100,
			str:"Some string",
			obj:
			{
				a:"bcd"
			},
			bool:true,
			mixed:"blah blah"
		};

		var JSONObjectSpec=
		{
			num:
			{
				allowedTypes:["number"],
				allowedValues:[1,100,1000,10000]
			},
			str:
			{
				allowedTypes:["string"]
			},
			obj:
			{
				allowedTypes:["object"]
			},
			bool:
			{
				allowedTypes:["boolean"]
			},
			mixed:
			{
				
			}
		};

		
		var curator=new TDPJSONCurator(objectToCurate, JSONObjectSpec, true);

		var prop="bool";
		var val=false;
		// get example, should work correctly:
		curator.set(prop, val, function(ret)
		{
			it("Should return true for a successful set()", function()
			{		
				ret.should.be.an.Object;
				ret.num.should.eql(objectToCurate.num);
				ret.str.should.eql(objectToCurate.str);
				ret.obj.should.eql(objectToCurate.obj);
				ret.bool.should.eql(val);
				ret.mixed.should.eql(objectToCurate.mixed);
			});
		});
	});


	describe("Sync constructor test 10", function()
	{
		var objectToCurate=
		{
			num:100,
			str:"Some string",
			obj:
			{
				a:"bcd"
			},
			bool:true,
			mixed:"blah blah"
		};

		var JSONObjectSpec=
		{
			num:
			{
				allowedTypes:["number"],
				allowedValues:[1,100,1000,10000]
			},
			str:
			{
				allowedTypes:["string"]
			},
			obj:
			{
				allowedTypes:["object"]
			},
			bool:
			{
				allowedTypes:["boolean"]
			},
			mixed:
			{
				
			}
		};

		
		var curator=new TDPJSONCurator(objectToCurate, JSONObjectSpec, true);

		var prop="mixed";
		var val=["abc",123,false];
		// get example, should work correctly:
		curator.set(prop, val, function(ret)
		{
			it("Should return true for a successful set()", function()
			{		
				ret.should.be.an.Object;
				ret.num.should.eql(objectToCurate.num);
				ret.str.should.eql(objectToCurate.str);
				ret.obj.should.eql(objectToCurate.obj);
				ret.bool.should.eql(objectToCurate.bool);
				ret.mixed.should.eql(val);
				assert.deepEqual(ret.mixed, val);
			});
		});
	});



	// invalid tests
	describe("Sync constructor test 11", function()
	{
		var objectToCurate=
		{
			num:100,
			str:"Some string",
			obj:
			{
				a:"bcd"
			},
			bool:true,
			mixed:"blah blah"
		};

		var JSONObjectSpec=
		{
			num:
			{
				allowedTypes:["number"],
				allowedValues:[1,100,1000,10000]
			},
			str:
			{
				allowedTypes:["string"]
			},
			obj:
			{
				allowedTypes:["object"]
			},
			bool:
			{
				allowedTypes:["boolean"]
			},
			mixed:
			{
				
			}
		};

		
		var curator=new TDPJSONCurator(objectToCurate, JSONObjectSpec, true);

		var prop="num";
		var val=99;
		// get example, should work correctly:
		curator.set(prop, val, function(ret)
		{
			it("Should return false for an successful set() due to invalid value", function()
			{		
				ret.should.be.eql(false);
			});
		});
	});

	describe("Sync constructor test 12", function()
	{
		var objectToCurate=
		{
			num:100,
			str:"Some string",
			obj:
			{
				a:"bcd"
			},
			bool:true,
			mixed:"blah blah"
		};

		var JSONObjectSpec=
		{
			num:
			{
				allowedTypes:["number"],
				allowedValues:[1,100,1000,10000]
			},
			str:
			{
				allowedTypes:["string"]
			},
			obj:
			{
				allowedTypes:["object"]
			},
			bool:
			{
				allowedTypes:["boolean"]
			},
			mixed:
			{
				
			}
		};

		
		var curator=new TDPJSONCurator(objectToCurate, JSONObjectSpec, true);

		var prop="num";
		var val="Dis guy must be a slien or sutin";
		// get example, should work correctly:
		curator.set(prop, val, function(ret)
		{
			it("Should return false for an successful set() due to invalid type", function()
			{		
				ret.should.be.eql(false);
			});
		});
	});


// GET()'s
	describe("Sync constructor get() test 1", function()
	{
		var objectToCurate=
		{
			num:100,
			str:"Some string",
			obj:
			{
				a:"bcd"
			},
			bool:true,
			mixed:"blah blah"
		};

		var JSONObjectSpec=
		{
			num:
			{
				allowedTypes:["number"],
				allowedValues:[1,100,1000,10000]
			},
			str:
			{
				allowedTypes:["string"]
			},
			obj:
			{
				allowedTypes:["object"]
			},
			bool:
			{
				allowedTypes:["boolean"]
			},
			mixed:
			{
				
			}
		};

		
		var curator=new TDPJSONCurator(objectToCurate, JSONObjectSpec, true);

		var prop="num";
		// get example, should work correctly:
		curator.get(prop, function(ret)
		{
			it("Should return correct value for a successful get()", function()
			{		
				ret.should.eql(objectToCurate[prop]);
			});
		});
	});

	describe("Sync constructor get() test 2", function()
	{
		var objectToCurate=
		{
			num:100,
			str:"Some string",
			obj:
			{
				a:"bcd"
			},
			bool:true,
			mixed:"blah blah"
		};

		var JSONObjectSpec=
		{
			num:
			{
				allowedTypes:["number"],
				allowedValues:[1,100,1000,10000]
			},
			str:
			{
				allowedTypes:["string"]
			},
			obj:
			{
				allowedTypes:["object"]
			},
			bool:
			{
				allowedTypes:["boolean"]
			},
			mixed:
			{
				
			}
		};

		
		var curator=new TDPJSONCurator(objectToCurate, JSONObjectSpec, true);

		var prop="str";
		// get example, should work correctly:
		curator.get(prop, function(ret)
		{
			it("Should return correct value for a successful get()", function()
			{		
				ret.should.eql(objectToCurate[prop]);
			});
		});
	});

	describe("Sync constructor get() test 4", function()
	{
		var objectToCurate=
		{
			num:100,
			str:"Some string",
			obj:
			{
				a:"bcd"
			},
			bool:true,
			mixed:"blah blah"
		};

		var JSONObjectSpec=
		{
			num:
			{
				allowedTypes:["number"],
				allowedValues:[1,100,1000,10000]
			},
			str:
			{
				allowedTypes:["string"]
			},
			obj:
			{
				allowedTypes:["object"]
			},
			bool:
			{
				allowedTypes:["boolean"]
			},
			mixed:
			{
				
			}
		};

		
		var curator=new TDPJSONCurator(objectToCurate, JSONObjectSpec, true);

		var prop="obj";
		// get example, should work correctly:
		curator.get(prop, function(ret)
		{
			it("Should return correct value for a successful get()", function()
			{		
				assert.deepEqual(ret, objectToCurate[prop]);
			});
		});
	});

	describe("Sync constructor get() test 2", function()
	{
		var objectToCurate=
		{
			num:100,
			str:"Some string",
			obj:
			{
				a:"bcd"
			},
			bool:true,
			mixed:"blah blah"
		};

		var JSONObjectSpec=
		{
			num:
			{
				allowedTypes:["number"],
				allowedValues:[1,100,1000,10000]
			},
			str:
			{
				allowedTypes:["string"]
			},
			obj:
			{
				allowedTypes:["object"]
			},
			bool:
			{
				allowedTypes:["boolean"]
			},
			mixed:
			{
				
			}
		};

		
		var curator=new TDPJSONCurator(objectToCurate, JSONObjectSpec, true);

		var prop="bool";
		// get example, should work correctly:
		curator.get(prop, function(ret)
		{
			it("Should return correct value for a successful get()", function()
			{		
				ret.should.eql(objectToCurate[prop]);
			});
		});
	});

	describe("Sync constructor get() test 3", function()
	{
		var objectToCurate=
		{
			num:100,
			str:"Some string",
			obj:
			{
				a:"bcd"
			},
			bool:true,
			mixed:"blah blah"
		};

		var JSONObjectSpec=
		{
			num:
			{
				allowedTypes:["number"],
				allowedValues:[1,100,1000,10000]
			},
			str:
			{
				allowedTypes:["string"]
			},
			obj:
			{
				allowedTypes:["object"]
			},
			bool:
			{
				allowedTypes:["boolean"]
			},
			mixed:
			{
				
			}
		};

		
		var curator=new TDPJSONCurator(objectToCurate, JSONObjectSpec, true);

		var prop="mixed";
		// get example, should work correctly:
		curator.get(prop, function(ret)
		{
			it("Should return correct value for a successful get()", function()
			{		
				ret.should.eql(objectToCurate[prop]);
			});
		});
	});


	describe("Sync constructor get() test 4", function()
	{
		var objectToCurate=
		{
			num:100,
			str:"Some string",
			obj:
			{
				a:"bcd"
			},
			bool:true,
			mixed:"blah blah"
		};

		var JSONObjectSpec=
		{
			num:
			{
				allowedTypes:["number"],
				allowedValues:[1,100,1000,10000]
			},
			str:
			{
				allowedTypes:["string"]
			},
			obj:
			{
				allowedTypes:["object"]
			},
			bool:
			{
				allowedTypes:["boolean"]
			},
			mixed:
			{
				
			}
		};

		
		var curator=new TDPJSONCurator(objectToCurate, JSONObjectSpec, true);

		var prop=undefined;
		// get example, should work correctly:
		curator.get(prop, function(ret)
		{
			it("Should return the curated object when no propertyName is passed to get()", function()
			{		
				assert.deepEqual(ret, objectToCurate);
			});
		});
	});

	// invalid tests
	describe("Sync constructor get() test 2", function()
	{
		var objectToCurate=
		{
			num:100,
			str:"Some string",
			obj:
			{
				a:"bcd"
			},
			bool:true,
			mixed:"blah blah"
		};

		var JSONObjectSpec=
		{
			num:
			{
				allowedTypes:["number"],
				allowedValues:[1,100,1000,10000]
			},
			str:
			{
				allowedTypes:["string"]
			},
			obj:
			{
				allowedTypes:["object"]
			},
			bool:
			{
				allowedTypes:["boolean"]
			},
			mixed:
			{
				
			}
		};

		
		var curator=new TDPJSONCurator(objectToCurate, JSONObjectSpec, true);

		var prop="badger";
		// get example, should work correctly:
		(function()
		{
			curator.get(prop, function(ret)
			{			
				it("Should throw an error for a non-existant prop in get()", function()
				{		
				});
			});
		}).should.throw();
	});


});


